unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Mask, ToolEdit, Placemnt, RXSpin, StdCtrls, Spin, StrUtils,
  RXShell, Menus, AppEvent;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Label78: TLabel;
    Label1: TLabel;
    UPSPort: TSpinEdit;
    CloseOnPowerOff: TCheckBox;
    PowerOffTimeout: TRxSpinEdit;
    ShutdownOnUPSTimeout: TCheckBox;
    RunOnPowerOn: TCheckBox;
    PowerOnTimeout: TRxSpinEdit;
    ProgramName: TFilenameEdit;
    RunnedTest: TCheckBox;
    RunnedTestTimeout: TRxSpinEdit;
    SignalLevel: TRadioGroup;
    PortSignal: TRadioGroup;
    Timer1: TTimer;
    FormStorage1: TFormStorage;
    RxTrayIcon1: TRxTrayIcon;
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    PopupMenu1: TPopupMenu;
    N3: TMenuItem;
    N4: TMenuItem;
    AppEvents1: TAppEvents;
    ForcedClosing: TCheckBox;
    TerminateTimeout: TRxSpinEdit;
    N5: TMenuItem;
    Label2: TLabel;
    Params: TEdit;
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure UPSPortChange(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure AppEvents1Minimize(Sender: TObject);
    procedure RxTrayIcon1Click(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure RxTrayIcon1DblClick(Sender: TObject);
    procedure N5Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
function ProcessRunned(ProcessHandle: THandle): Boolean;
function EnumFunc(H:HWND; Par:lParam):Boolean; stdcall;
procedure RunProgram(S: String);
procedure CloseProgram(ProcessHandle: THandle; ThreadId: DWORD; ForcedFlag: Boolean);

var
  Form1: TForm1;
  UPSHandle,ProcessHandle: THandle;
  PowerGood: Boolean=True;
  PowerWasGood: Boolean=True;
  RunnedFlag: Boolean=False;
  ThreadId: DWORD;
  WindowsList: TList;

implementation

{$R *.DFM}

function ProcessRunned(ProcessHandle: THandle): Boolean;
var TerminateStatus: DWORD;
begin
  Result:=(ProcessHandle<>0) and GetExitCodeProcess(ProcessHandle,TerminateStatus) and
          (TerminateStatus=STILL_ACTIVE);
end;

function EnumFunc(H:HWND; Par:lParam):Boolean; stdcall;
var PH: HWND;
begin
  PH:=GetParent(H);
  if PH=0{GetDesktopWindow} then WindowsList.Add(Pointer(H));
  Result:=True;
end;

procedure RunProgram(S: String);
var StartInfo: TStartupInfo; ProcInfo: TProcessInformation; S1,S2: String;
begin
  FillChar(StartInfo, SizeOf(TStartupInfo), 0);
  StartInfo.cb := SizeOf(TStartupInfo);
  if (CreateProcess(nil, PChar(S), nil, nil, false, NORMAL_PRIORITY_CLASS, nil,
                    PChar(ExtractFilePath(S)), StartInfo, ProcInfo)) then begin
    ProcessHandle:=ProcInfo.hProcess;
    ThreadId:=ProcInfo.dwThreadId;
  end else MessageDlg(SysErrorMessage(GetLastError), mtError, [mbOk], 0);
end;

procedure CloseProgram(ProcessHandle: THandle; ThreadId: DWORD; ForcedFlag: Boolean);
var I: Integer;
begin
  if ForcedFlag then begin
    TerminateProcess(ProcessHandle,1);
{    CloseHandle(ProcInfo.hThread);
    CloseHandle(ProcessHandle);}
  end else begin
    WindowsList.Clear;
    EnumThreadWindows(ThreadId,@EnumFunc,0);
    for I:=0 to WindowsList.Count-1 do
      PostMessage(HWND(WindowsList[I]),WM_CLOSE,100,0);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  WindowsList:=TList.Create;
  FormStorage1.RestoreFormPlacement;
  UPSPort.OnChange(nil);
  Timer1.Enabled:=True;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Timer1.Enabled:=False;
  CloseHandle(UPSHandle);
  WindowsList.Free;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var I,Stat,TestedSignal: Integer; PowerGood, RunNeed, Runned: Boolean;
begin
  PowerGood:=True; //    
  RunNeed:=False;  //   
  if (UPSHandle<>INVALID_HANDLE_VALUE) then begin
    GetCommModemStatus(UPSHandle,Stat);
    case PortSignal.ItemIndex of
    0: TestedSignal:=MS_RLSD_ON;
    1: TestedSignal:=MS_DSR_ON;
    2: TestedSignal:=MS_CTS_ON;
    3: TestedSignal:=MS_RING_ON;
    end;
    PowerGood:=((Stat and TestedSignal)<>0) xor (SignalLevel.ItemIndex=0);
  end;
  if PowerGood then begin
    PowerOffTimeout.Tag:=0;
    RxTrayIcon1.Icon.Assign(RxTrayIcon1.Icons[0]);
    if PowerWasGood then begin
      PowerOnTimeout.Tag:=PowerOnTimeout.Tag+1; //      
      RunnedTestTimeout.Tag:=RunnedTestTimeout.Tag+1; //   ,   
      if (RunOnPowerOn.Checked and (PowerOnTimeout.Tag=PowerOnTimeout.Value)) then RunNeed:=True;
      if (RunnedTest.Checked and (RunnedTestTimeout.Tag>RunnedTestTimeout.Value)) then begin
        RunnedTestTimeout.Tag:=0;
        RunNeed:=True;
      end;
      Runned:=ProcessRunned(ProcessHandle);
      if not Runned and RunNeed then RunProgram(ProgramName.FileName+' '+Params.Text);
    end;
  end else begin
    PowerOnTimeout.Tag:=0;
    RxTrayIcon1.Icon.Assign(RxTrayIcon1.Icons[1]);
    if not PowerWasGood then begin
      PowerOffTimeout.Tag:=PowerOffTimeout.Tag+1; //     
      if CloseOnPowerOff.Checked and (PowerOffTimeout.Tag=PowerOffTimeout.Value) then begin
        Runned:=ProcessRunned(ProcessHandle);
        if Runned then begin
          if ForcedClosing.Checked then TerminateTimeout.Tag:=1; //     
          CloseProgram(ProcessHandle,ThreadId,False);
        end;
        if ShutdownOnUPSTimeout.Checked then ExitWindowsEx(EWX_FORCE or EWX_SHUTDOWN or EWX_POWEROFF,0);
      end;
    end;
  end;
  if TerminateTimeout.Tag<>0 then TerminateTimeout.Tag:=TerminateTimeout.Tag+1; //         
  if TerminateTimeout.Tag>TerminateTimeout.Value then begin
    TerminateTimeout.Tag:=0;
    Runned:=ProcessRunned(ProcessHandle);
    if Runned then CloseProgram(ProcessHandle,ThreadId,True);
  end;
  PowerWasGood:=PowerGood; //     
end;

procedure TForm1.UPSPortChange(Sender: TObject);
begin
  if CloseOnPowerOff.Checked then begin
    CloseHandle(UPSHandle);
    UPSHandle:=CreateFile(PChar('COM'+IntToStr(UPSPort.Value)+':'),GENERIC_READ,FILE_SHARE_READ,nil,OPEN_EXISTING,0,0);
    if UPSHandle=INVALID_HANDLE_VALUE then ShowMessage('   COM'+IntToStr(UPSPort.Value)+' ( UPS) !')
                                      else EscapeCommFunction(UPSHandle,SETRTS);
                                      {else ClearCOM(UPSHandle)};
  end;
end;

procedure TForm1.N2Click(Sender: TObject);
begin
  Form1.Close;
end;

procedure TForm1.N1Click(Sender: TObject);
begin
  FormStorage1.SaveFormPlacement;
end;

procedure TForm1.N3Click(Sender: TObject);
begin
  Application.Restore;
end;

procedure TForm1.AppEvents1Minimize(Sender: TObject);
begin
  RxTrayIcon1.Active:=True; Form1.Hide; ShowWindow(Application.Handle, SW_HIDE);
end;

procedure TForm1.RxTrayIcon1Click(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  PopupMenu1.Popup(X,Y);
end;

procedure TForm1.RxTrayIcon1DblClick(Sender: TObject);
begin
  Application.Restore;
  Application.BringToFront;
end;

procedure TForm1.N5Click(Sender: TObject);
var S: String;
begin
  S:=' UPSMonitor           UPS''.'+#13#10#13#10+
     '          '+#13#10+
     '( PostMessage(HWND,WM_CLOSE,100,0) ),'+#13#10+
     '       ( TerminateProcess(ProcessHandle,1) ).'+#13#10#13#10+
     ' :  , eugene@kalinin.kirov.ru.';
  MessageBox(Screen.ActiveForm.Handle,PChar(S),PChar('  UPSMonitor'),0);
end;

end.
